;****************************************************************
;  7.0      ADIF    "1"!!!
;		   
;		    (3000-300) 
;		     
;		 Progress bar ()   
;		      
;
; 8.1	    "U"  "S"
;
;
;****************************************************************
.nolist
.include "tn13def.inc" 	
.list
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;                         Name Constants
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

; define Output-Pin (change to your needs)
 
.equ SegDDR=DDRB	;DDR for 7-Segment Hardware
.equ SegPort=PORTB	;Port for 7-Segment Hardware
.equ SegPin=PB5		;Output-Pin for 7-Segment Hardware

;**** DP  .       "3x7Segment.inc"
;	       

.equ DP = 0			;set DP to 0 to supress Dezimalpoint at all
					;set DP to 3 to show Decimalpoint on S_High 7-Segment
					;set DP to 2 to show Decimalpoint on High 7-Segment
					;set DP to 1 to show Decimalpoint on middle 7-Segment
					;Dezimalpoint on right 7-Segment is not implemented but
					;can be done

;    DP      :
.equ DP_Bit = 0x7F	;Bit-Position of Decimal-Point on Shift-Register
					;-->     can NOT be changed !   <--
					;--> fixed Position by Hardware <--

.equ xtal = 9600000	;Your Clock in Hz (500KHz to 8MHz)
.equ Del_Val = xtal/100000

.equ AtBCD0	= 13	;  
.equ AtBCD2	= 15	;
.equ nADC 	= 16	;   
.equ n2 	= 4		; 2   n2 =   

;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;                         Name Registers
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

.def Reserved	= r0	;needed for LPM
.def Byte_Low 	= r1	;used in "3x7Segment.inc"
.def Byte_Med	= r2	;used in "3x7Segment.inc"
.def Byte_High	= r3	;used in "3x7Segment.inc"
.def Byte_S_High= r4	;used in "3x7Segment.inc" >>>>>>>>
.def Clear_flag = r6 	;   : ,  = 1

.def SummL 	= r7	;     ,  
.def SummH	= r8	;     ,  
.def temp1 	= r9	; general Purpose
.def temp2 	= r10	; general Purpose
.def cnt_An1= r11	;    (-)
.def cnt_An2= r12	;    

.def tBCD0 =r13    ;BCD value digits 1 and 0
.def tBCD1 =r14    ;BCD value digits 3 and 2
.def tBCD2 =r15    ;BCD value digit 4
.def cnt16a =r23   ;loop counter
.def tmp16a =r24   ;temporary value

.def Band = r25	 	;  :
					;  0 - : =1, =0 (300/3000)
					;  1 -     = 1,  = 0
					;  2 -     = 1,  = 0
					;  3 -   = 1
					;  4 -   : 1- 
					;  5 -   : 1-
					
.def DataL		= r16	;Data to 3x7-Segment-Display
.def DataH 		= r17	;Data to 3x7-Segment-Display
.def Temp 		= r18	;general Purpose
.def TempA 		= r19	;general Purpose
.def TempB 		= r20	;general Purpose
.def TempC 		= r21	;     
.def Byte_Out 	= r22	;used in "3x7Segment.inc"


;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
;                        Interrupt-Vectors
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

.CSEG
.ORG 0x0000			

	rjmp RESET 	;	Reset 
	reti		;	External Interrupt 0
	reti		;	External Interrupt Request 0
	rjmp T_OVF	;	Timer/Counter0 Overflow
	reti		;	EEPROM Ready
	reti		;	Analog Comparator
	reti		;	Timer/Counter Compare Match A
	reti		; 	Timer/Counter Compare Match B
	reti		;	Watchdog Time-out
	reti		;	ADC Conversion Complete

Reset:
; -------------  ""  (  0xFF   .  ---------------
;	ldi Temp, 0x59
;	out OSCCAL, Temp


; -------------   ---------------

	ldi r16,RAMEND			
	out spl,r16


; -------------   ---------------

; 	PB0,PB5 - , 	PB1,2,3,4 - 
;	PB0,PB5 - 0,0, 		PB1,2,3,4 - 0,0,0,0	
	ldi Temp, 0b00100001
	out	DDRB, Temp
	clr  Temp		;      
	out	PORTB, Temp


; -------------   ---------------

	ldi Temp,0x80	; 
	out ACSR,Temp


; -------------   ---------------
	
	ldi Temp,0x83
	out TCCR0A,Temp	; FastPWM,     0
	clr Temp
	out TCCR0B,Temp	;  
	out OCR0A,Temp	;   


; -------------   ---------------

	ldi Temp,0x85
	out ADCSRA, Temp	; , . , ,   9,6/64=150
	clr Temp
	out ADCSRB, Temp


; ********************************************************
; *******************   *******************
; ********************************************************

	
		clr Band		;  ()  

;+++++++++++++++ ,     

		in		Temp,PINB
		sbrc	Temp,1		;  ,  
		rjmp No_serv
		rcall 	Delay_50m		;   
		sbr	Band, 0x20		;  5   
							
	S_wait:					;  ,    
		in		Temp,PINB
		sbrs 	Temp,1		; 
		rjmp	S_wait
		rcall 	Delay_50m		;   
		rcall Out_Serv
		rjmp Wait

No_serv:

;--------     --------
	rcall Out_Auto
		
;--------    "" --------
Wait:
	in		Temp,PINB
	sbrc 	Temp,1		; 
	rjmp	Wait		
		rcall 	Delay_50m		;   
;--------  "" ,        

	cli		;  
	cbr Band, 0xDF		;    
	  
		sbrc Band, 5
;----------     - -   ----------
		rcall Out_Serv
		rcall Out_Start
		

;---------    ----	
	clr TempC			;  
	out OCR0A,TempC	;   
	ldi Temp,0x83		; 
	out TCCR0A,Temp		;   ,  FastPWM,     0
	ldi Temp, (1<<CS01)|(1<<CS00)	;   = clk/64
	out TCCR0B,Temp	;  ,    "" 

	clr cnt_An1			;   
	clr cnt_An2


; **************    ************
pwm1:	
	out OCR0A,TempC
	rcall Delay_L		;     

		;   ( 5 =0),     (No_serv1)
		;   ( 5 =1)  ,   . 
		sbrs Band, 5
		rjmp No_serv1
		
		in		Temp,PINB	; ,   
		sbrc 	Temp,1		; 
		rjmp	Exit_1		; (1),    pwm1     
		rjmp Stop_Exit		; (0),        pwm1,



No_serv1:
; **************  -  ************

	mov Temp, cnt_An2
	cpi Temp, 15	;  =21,     
	brne No_show
	
	ldi		ZH, high(AnimaTable*2)
	ldi		ZL, low(AnimaTable*2)
	add		ZL, cnt_An1	
	lpm					

	mov Byte_Out,r0
	rcall 	OutByte			
	
	clr cnt_An2 	;    2 
	inc cnt_An1	

No_show:
	inc cnt_An2
	mov Temp, cnt_An1
	cpi Temp, 16	;  Temp=16,   cnt_An1 (   " ")
	brne No_clear 
	clr cnt_An1
No_clear:

; **************      ******

	ldi TempA, (1<<MUX0)	;   ADC1(PB2), pin7
	out ADMUX, TempA
	rcall Read_ADC

;rcall hex2dec	;   (    )
;rcall Delay
	
	mov TempA, DataH
	mov TempB, DataL
	subi TempB, 0xE8
	sbci TempA, 0x03	;   1000 (0x3E8)
	brmi Stop_1
	
	rjmp Stop_Exit

Stop_1:
	mov TempA, DataH
	mov TempB, DataL
	subi TempB, 0x00
	sbci TempA, 0x02	;   512 (0x200)
	brmi Stop_2
	
	sbr Band, 0x02		;  1   
	rjmp Exit_1

Stop_2:
	mov TempA, DataH
	mov TempB, DataL
	subi TempB, 0x7C
	sbci TempA, 0x01	;   380 (0x17C)
	brmi Stop_3
	
	sbr Band, 0x04		;  2  
	rjmp Exit_1

Stop_3:
	sbr Band, 0x06		;  1  2   (  )
	rjmp Exit_1
	 
Stop_Exit:				; 

	inc TempC			;  
	cpi TempC,0xFF		;   ?
	brne pwm1			; ,   ,  

Exit_1:
	rcall Delay		;   	
	rcall Delay
	rcall Delay
Wait_pwm:
	rcall Delay

;*********************************************************
;*******      *******
;*********************************************************

	ldi Temp, (1<<MUX1)	;   ADC2(PB4), pin3
	out ADMUX, Temp
	rcall Read_ADC


;*******    *******************
;  <300,   
;     4, 300 -  75  04
		cbr Band, 0x01		;   (0   )
	mov Temp, DataH
	cpi Temp, 0x00
	brne Diap_1
	mov Temp, DataL
	subi Temp, 75
	brsh Diap_1

;*********************************************************
;*******      ********
;*********************************************************

	sbr Band, 0x01		;   (1   )
	ldi Temp, (1<<MUX1)|(1<<MUX0)	;   ADC3(PB3), pin2
	out ADMUX, Temp
	rcall Read_ADC
	

;*******   ,  ********

Diap_1:	
	lsl DataL	;   750 -> 3000    4 
	rol DataH	;    ,    4 
	lsl DataL	;      Read_ADC:   
	rol DataH	;     16,   4.
	
	rcall hex2dec	;   
	
;   ,           pwm1 +++++++++++++						
;    -  
		sbrs Band, 5
		rjmp Exit_2
;Wait_pwm:
		in		Temp,PINB
		sbrc 	Temp,1		; 
		rjmp	Wait_pwm		
		
		rcall	Delay_50m		;   
		rcall	Out_Start	;   
		
		rjmp 	pwm1


Exit_2:
; ****************   *****************
	ldi Temp,0x03		; 
	out TCCR0A,Temp	;    PB0
	clr Temp
	out TCCR0B,Temp	;  

;      HV 
 	rcall Delay
	rcall Delay
	rcall Delay

; ***************    **********

	mov Temp, Band
	andi Temp, 0b00000010
	cpi Temp, 0
	breq Run_1	; ,    
				;    ,    :

; -------------     ---------------
	
	clr Temp
	out TCCR0A,Temp	; Normal
	out TCCR0B,Temp	;  
	out OCR0A,Temp	;   
	ldi Temp, 0x02	;     
	out TIMSK0, Temp	

	; ---------    ----	
	
	ldi Temp, (1<<CS02)|(1<<CS00)	;   = clk/1024
	out TCCR0B,Temp	;  ,    
	
	clr temp1		;      
	clr temp2
	
	rcall Sound_Fail ;      
	rcall Delay
	rcall Sound_Fail
	
	sei			;  
	rjmp Run_2

Run_1:		
	rcall Sound_OK	;     

Run_2:
	rjmp Wait	; >>     ""





;******************     ******************

T_OVF:

	push Temp	

	inc temp1		;  25   (5/7 )
	mov Temp, temp1
	cpi Temp, 25
	brne Ex_1
	
	mov Temp, temp2
	cpi Temp, 1
	brne Out_1
	rcall hex2dec	; >>>   			; 	
	
	clr temp1
	ldi Temp, 0
	mov temp2, Temp
	rjmp Ex_1

Out_1:
	rcall Out_Clear	; >>>   
	clr temp1
	ldi Temp, 1
	mov temp2, Temp
	
Ex_1:
	pop Temp
	reti



;******************   *************************
;******      ****

Sound_OK:
	clr Temp	
	sbi	DDRB, 1		; PB1 -  
	
	cbi	PORTB, 1
	rcall Delay
	;rcall Delay
	sbi PORTB,1
	rcall Delay_S
	rcall Delay_S

	cbi	PORTB, 1
	rcall Delay
	;rcall Delay
	sbi PORTB,1
	rcall Delay_S
	rcall Delay_S

	cbi DDRB, 1
	ret

Sound_Fail:
	clr Temp	
	sbi	DDRB, 1		; PB1 -  
	
	cbi	PORTB, 1
	rcall Delay
	;rcall Delay_S
	sbi PORTB,1
	rcall Delay_S
	rcall Delay_S

	cbi	PORTB, 1
	rcall Delay
	;rcall Delay_S
	sbi PORTB,1
	rcall Delay_S
	rcall Delay_S

	cbi	PORTB, 1
	rcall Delay
	;rcall Delay_S
	sbi PORTB,1
	rcall Delay_S
	rcall Delay_S
	
	
	
	cbi DDRB, 1
	ret



;**********   ************
Delay:
	push Temp
	clr Temp
Delay0:
	;ldi  TempA, $04
	ldi  TempA, $0F
Delay1:
	ldi  TempB, $C4
Delay2:
	dec  TempB
    brne Delay2
    dec  TempA
    brne Delay1
    dec  Temp
    brne Delay0
	pop Temp
	ret

;*********       *****
Delay_L:
	
	push Temp
	clr Temp
Del0:
	ldi  TempA, $04
Del1:
	;ldi  TempB, $14
	ldi  TempB, $C4
Del2:
	dec  TempB
    brne Del2
    dec  TempA
    brne Del1
    dec  Temp
    brne Del0
	pop Temp
	ret
	
;*********    *****
Delay_S:
	clr Temp
Des0:
	ldi  TempA, $04
Des1:
	;ldi  TempB, $14
	ldi  TempB, $C4
Des2:
	dec  TempB
    brne Des2
    dec  TempA
    brne Des1
    dec  Temp
    brne Des0
	ret

;*********  50 mS *****
Delay_50m:
	push Temp
	
	ldi TempB, 0x02		;  0,1s (9600000/5/10=192000=0x02EE00)
	ldi TempA, 0xEE
	ldi Temp, 0x00
Del_1:
	subi Temp,1
	sbci TempA,0
	sbci TempB,0
	brcc Del_1

	pop Temp
	ret




;******************          ******************
;*****     DataH, DataL  ******
;*****     DataH, DataL ******
;*****  nADC                     ******

Read_ADC:	
	
	push Temp
	clr SummL
	clr SummH
	clr TempA 
	
adc_0:	
	sbi ADCSRA,ADSC		;  
adc_1:	
	in		Temp, ADCSRA	;   ADIF=1 =  
	sbrs 	Temp,4
	;sbrc 	Temp,6			;       ADSC ( )
	rjmp	adc_1			;   
	sbi	ADCSRA, ADIF		;     ( "1" !!!)
		
	in DataL, ADCL
	in DataH, ADCH	
	
	add SummL, DataL
	adc SummH, DataH	;   

	inc TempA			;  
	cpi TempA,nADC 		;   ?
	brne adc_0			; ,   ,  
	
	clr TempA	;     
div16:	
	lsr SummH
	ror SummL
	inc TempA
	cpi TempA, n2
	brne div16

	mov DataL, SummL
	mov DataH, SummH 
	
ret_1:
	pop Temp
	ret

;******************   U ******************
Out_Auto:
	ldi Byte_Out,0x08	;"_" on right Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on middle Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on left Display
	rcall OutByte
	ldi Byte_Out,0x77	;"A" on L_left Display
	rcall OutByte
	ret


;******************   Start ******************
Out_Start:
	ldi Byte_Out,0x08	;"_" on right Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on middle Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on left Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on L_left Display
	rcall OutByte
	ret

;******************   Service ******************
Out_Serv:
	ldi Byte_Out,0x08	;"_" on right Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on middle Display
	rcall OutByte
	ldi Byte_Out,0x08	;"_" on left Display
	rcall OutByte
	ldi Byte_Out,0x73	;"P" on L_left Display
	rcall OutByte
	ret


;******************   ******************
Out_Clear:
	ldi Byte_Out,0x00	
	rcall OutByte
	ldi Byte_Out,0x00	
	rcall OutByte
	ldi Byte_Out,0x00	
	rcall OutByte
	ldi Byte_Out,0x00	
	rcall OutByte
	ret


.include "3x7Segment.inc"

;----------- end of program ------------------
