;----------------------------------------
; "3x7Segment.inc"     "4x7Segment.inc"-    !
;----------------------------------------
;
;input : Register "Data" = 8 bit (value 0..255)
;output: Byte_High,Byte_Med,Byte_Low = Decimal Numbers >>>>>>> Byte_S_High	= r4
;        in low nibble of registers
;used  : Temp,TempA,TempB,ZH,ZL,r0,Byte_Out,Clear_flag -   
;
; First convert to decimal
hex2dec:
	push Temp

	rcall bin2BCD16


; >>>> now save only low nibbles of converted values (0 to 9)
	mov		Temp,tBCD1
	swap	Temp
	andi	Temp,0x0F
	mov		Byte_S_High,Temp
	mov		Temp,tBCD1
	andi	Temp,0x0F
	mov		Byte_High,Temp

	mov		Temp,tBCD0
	swap	Temp
	andi	Temp,0x0F
	mov		Byte_Med,Temp
	mov		Temp,tBCD0
	andi	Temp,0x0F
	mov		Byte_Low,Temp


Clear_Fl:

;>>>>      
	clr		Clear_flag		;  

;>>>>    () 
	mov		Temp,Byte_S_High
	tst		Temp
	brne	No_Flag_4
	ldi		Temp,0x0A
	mov		Byte_S_High, Temp
	ldi		Temp,0x01
	mov		Clear_flag,Temp

No_Flag_4: 		

;>>>>     ()
	mov		Temp,Clear_flag
	tst		Temp
	breq	No_Flag_3
	mov		Temp,Byte_High	;  ,  Clear_flag=1 (S_High  - )
	tst		Temp
	breq	Clear_3		;  High   ,     
	clr		Clear_flag
	rjmp	No_Flag_3
Clear_3:
	ldi		Temp,0x0A
	mov		Byte_High, Temp
	ldi		Temp,0x01
	mov		Clear_flag,Temp

No_Flag_3:

;>>>>     ()
	mov		Temp,Clear_flag
	tst		Temp
	breq	No_Flag_2
	
	mov		Temp,Byte_Med
	tst		Temp
	breq	Clear_2
	clr		Clear_flag
	rjmp	No_Flag_2
Clear_2:
	ldi		Temp,0x0A
	mov		Byte_Med, Temp
	ldi		Temp,0x01
	mov		Clear_flag,Temp

No_Flag_2:

;>>>>       
;>>>>    ,    Byte_Med      
	mov		Temp,Clear_flag
	tst		Temp
	breq	No_Flag_1
	
	ldi		Temp,0x00
	mov		Byte_Med, Temp
	clr		Clear_flag

No_Flag_1:
	nop

Out_7Segment:

;!!!    DP         !!!

; Do a table lookup on the low nibble of Byte_Low ============= 1
	ldi		ZH, high(SegTable*2)
	ldi		ZL, low(SegTable*2)
	add		ZL,Byte_Low

	lpm						;load Segment-Info
	mov Byte_Out,r0
	rcall 	OutByte			;and shift out

; Do a table lookup on the low nibble of Byte_Med ============= 2
	ldi		ZH, high(SegTable*2)
	ldi		ZL, low(SegTable*2)
	add		ZL,Byte_Med


	lpm						;load Segment Info
	ldi		TempA,DP		;should we display Dezimal-Point? 
	tst		TempA
	breq	No_DP1			;not at all
	cpi		TempA,1			;display DP on middle 7-Segment?
	brne	No_DP1			;no
	ldi		TempA,DP_Bit	;yes,clear DP-Bit to show DP
	and		r0,TempA
No_DP1:
	mov		Byte_Out,r0
	rcall 	OutByte			;and shift out
; Do a table lookup on the low nibble of Byte_High ============ 3
	ldi		ZH, high(SegTable*2)
	ldi		ZL, low(SegTable*2)
	add		ZL,Byte_High

	lpm						;load Segment-Info
	ldi		TempA,DP		;should we display Dezimal-Point? 
	tst		TempA
	breq	No_DP2			;not at all
	cpi		TempA,2			;display DP on left 7-Segment?
	brne	No_DP2			;no
	ldi		TempA,DP_Bit	;yes,clear DP-Bit to show DP
	and		r0,TempA

No_DP2:
	mov Byte_Out,r0
	rcall 	OutByte			
;
;>>>>>>>>> S_High_Number!!  >>>>>>>>>>>>>>>>>>>>>
; Do a table lookup on the low nibble of Byte_S_High ========== 4
	ldi		ZH, high(SegTable*2)
	ldi		ZL, low(SegTable*2)
	add		ZL,Byte_S_High

	lpm						;load Segment-Info
	ldi		TempA,DP		;should we display Dezimal-Point? 
	tst		TempA
	breq	No_DP3			;not at all
	cpi		TempA,3			;display DP on left 7-Segment?
	brne	No_DP3			;no
	ldi		TempA,DP_Bit	;yes,clear DP-Bit to show DP
	and		r0,TempA
No_DP3:
	mov Byte_Out,r0
	rcall 	OutByte

;********    (1),     1  *****	
	
	sbrs Band, 0
	rjmp Diap_2		; ,  Band.0=0 () 
	ldi Byte_Out,0	;
	rcall OutByte	;  ""  -   
	 
Diap_2:
	pop Temp
	ret



;------- Shifts Register "Out_Byte" into Hardware --------
; input : Byte to be sent in Byte_Out
; used  : TempA,TempB,Byte_Out
; Stack used : 0
;---------------------------------------------------------
OutByte:
		
	ldi	TempA,8				; load Bit Counter
	sbi	SegPORT,SegPIN		; set Output High
Next_Bit:
	lsl	Byte_Out			; Shift next bit into carry
	brcs	Write_One
Write_Zero:
	cbi	SegPORT,SegPIN		; if a zero, pin is low for delay-time
Write_One:					; if a one, pin stays high for delay-time
	ldi TempB,Del_Val		; delay-time
Delay_E1:
  	dec	TempB
    brne 	Delay_E1
	cbi	SegPORT,SegPIN		; edge falls here
	sbi	SegPORT,SegPIN		; rising edge clocks data into 74HCT164
	dec	TempA				; Decrement BitCount
	brne Next_Bit			; all Bits done ?

	ret						; yes					

; >>>>>>>>>>>>>>> bin16-to-bcd5 >>>>>>>>>>>>>>>>
;***************************************************************************
;*
;* "bin2BCD16" - 16-bit Binary to BCD conversion
;*
;* This subroutine converts a 16-bit number (fbinH:fbinL) to a 5-digit 
;* packed BCD number represented by 3 bytes (tBCD2:tBCD1:tBCD0).
;* MSD of the 5-digit number is placed in the lowermost nibble of tBCD2.
;*  
;* Number of words :29
;* Number of cycles :751/768 (Min/Max)
;* Low registers used :3 (tBCD0,tBCD1,tBCD2) 
;* High registers used  :2(fbinL,fbinH,cnt16a,tmp16a) 
;* Pointers used :Z
;* Stack used : 2
;*
;***************************************************************************

bin2BCD16:

	push DataL
	push DataH

ldi cnt16a,16	;Init loop counter 
clr tBCD2 		;clear result (3 bytes)
clr tBCD1  
clr tBCD0  
clr ZH 			;clear ZH (not needed for AT90Sxx0x)

bBCDx_1:
lsl DataL 		;shift input value
rol DataH 		;through all bytes
rol tBCD0 		;
rol tBCD1
rol tBCD2
dec cnt16a 		;decrement loop counter
brne bBCDx_2 	;if counter not zero

	pop DataH
	pop DataL

ret  			;   return

bBCDx_2:
ldi r30,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:
ld tmp16a,-Z		;get (Z) with pre-decrement

subi tmp16a,-$03	;add 0x03
sbrc tmp16a,3		;if bit 3 not clear
st Z,tmp16a			; store back
ld tmp16a,Z			;get (Z)
subi tmp16a,-$30	;add 0x30
sbrc tmp16a,7		;if bit 7 not clear
st Z,tmp16a			; store back
cpi ZL,AtBCD0		;done all three?
brne bBCDx_3 		;loop again if not
rjmp bBCDx_1


;------------------------------------------------------------------
; A "0" bit equals TTL low, grounding the corresponding segment
; and turning it off.
;
; Register "Byte_Out" -> 7-Segment Matrix:
;
; Bit 0 Segment A,Bit 1 Segment B,Bit 2 Segment C,Bit 3 Segment D,
; Bit 4 Segment E,Bit 5 Segment F,Bit 6 Segment G,Bit 7 Segment H(DP)
;------------------------------------------------------------------
SegTable:
;		0    1    2    3    4    5    6    7    8    9      
;	.db	0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90	;	  
	.db	0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F 	;	  

;       
;Special_Characters:
;   	blank  B    C    D    E    F    DP   H    L    G    Y    Minus
;	.db 0xFF,0x83,0xC6,0x91,0x96,0x8E;,0x80,0x89,0xC7,0x82,0x91,0xBF ;	  
	.db 0x00,0x7C,0x39,0x6E,0x69,0x71;,0x80,0x89,0xC7,0x82,0x91,0xBF ;	  

AnimaTable:	;	  
	.db	0x00,0x00,0x00,0x00,0x08,0x08,0x08,0x08,0x48,0x48,0x48,0x48,0x49,0x49,0x49,0x49


